\chapter{Acceleration Options}




\section{Pre-Conditions}
The author setup the Whisker project as follows:

\begin{lstlisting}[language=BASH]
git clone https://github.com/se2p/whisker-main && cd whisker-main
npm install && npm run build
cd ..
git clone https://github.com/se2p/whisker-web && cd whisker-web
npm install && npm run build
\end{lstlisting}

At that time, the shortened git commit hash for the Whisker-Main repository was \texttt{680877b}, and for the Whisker-Web repository was \texttt{c4040f0}. Every modification and result in this thesis is based on the state of the code at those commits.




\section{Headless-mode}
The initial assumption was that the rendering process itself would be the bottleneck. Additionally, being able to run the tests in a headless environment was considered an advantage on its own. Therefore the first approach to achieve an accelerated execution was to evaluate how the test runner could be implemented without rendering. This will from now on be referred to as the headless-mode. The following sections show the approaches which have been evaluated to realize such a headless-mode.


\subsection{Decoupling the Scratch VM from the renderer}
Decoupling the Scratch VM from the Scratch-Renderer was a possible approach, by replacing the renderer object used by the Scratch VM with an object stubbing the behavior of the original renderer and its internal state, without actually writing or using any canvas element.
Currently, the renderer gets attached to the runtime object via the Scratch VM \texttt{attachRenderer} method exposed to the VM Instance. The default renderer object is an instance of the RenderWebGL class and exposes a rich API, including the original canvas context.

At this point, it became clear that stubbing the complete API exposed by the renderer and keeping the stub in sync with the upstream changes would be a very maintaining intensive and long-running task. This approach would increase the maintenance costs and possibly break test runs because of functionality used by the tested application but not yet ported back from upstream to the stub. Therefore the idea was rejected.


\subsection{Running the Tests via Headless Chrome}
As Whisker-Web allows users to run tests in a browser, considering the \texttt{--headless} flag of Google Chrome seemed to be a possible solution. Modern test frameworks for JavaScript applications use Headless Chrome as the execution environments for their unit and integration tests, as it can be run on headless (continuous integration) servers. The headless flag enables developers to run Google Chrome in headless environments, allowing users to execute HTML, CSS, and JavaScript code in a browser without rendering. Instead of merely using Headless Chrome directly, the author decided to utilize \textbf{Puppeteer}, a \flqq Headless Chrome Node.js API\frqq{}, which is provided by the Chrome DevTools team as an open-source project via GitHub \cite{puppeteer}.

Puppeteer is available as an npm module, packages Google Chrome, allows developers to start it in the headless mode, and exposes an API to interact with the Google Chrome instance programmatically. The following example shows how Puppeteer launches a headless Google Chrome instance, opens a new tab, loads a website via the supplied URL, and clicks the button with the id \texttt{click-me-button}. Then it closes the chrome instance and exits the program.
\begin{lstlisting}[language=ES6]
const puppeteer = require('puppeteer');

(async () => {
  const browser = await puppeteer.launch();
  const page = await browser.newPage();
  await page.goto('https://some-website.com');

  const buttonWeWantToClick = await page.$('#click-me-button');
  await buttonWeWantToClick.click();

  await browser.close();
})();
\end{lstlisting}
As the example shows, the Puppeteer API is quite straightforward. The documentation is extensive and allows us to easily interact with every Document Object Model (DOM) element, select files for file uploads, and read or write data to the DOM \cite{puppeteerDocs}.


The following example shows in detail how Puppeteer can be used to run a Whisker test-suite in headless-mode. Copying the following code to a file named \texttt{servant.js}, installing node and npm for the used operating system, and running \texttt{npm install puppeteer} in the same directory is sufficient to get setup. The \texttt{servant.js} file, the files containing the Whisker tests, and the Scratch application must all be located in a new directory. The whisker-web project must be available at the URL \texttt{http://localhost:8080}. Of course, all the referenced files (project.sb3, tests.js) can also be located somewhere else. Then the paths have to be updated accordingly. Also instead of using \texttt{http://localhost:8080} the \texttt{index.html} file in the dist folder of the \texttt{whisker-web} project can be referenced via the filehandle, example: \texttt{file:///home/username/development/index.html}.

If the setup is done correctly the program can be executed via \texttt{node servant.js}.
\begin{lstlisting}[language=ES6]
const puppeteer = require('puppeteer');

(async () => {
  const browser = await puppeteer.launch({ headless: true });
  const page = await browser.newPage();

  await page.goto('http://localhost:8080', { waitUntil: 'networkidle0' });

  const projectFileInput = await page.$('#fileselect-project');
  await projectFileInput.uploadFile('./project.sb3');

  const testFileInput = await page.$('#fileselect-tests');
  await testFileInput.uploadFile('./tests.js');

  const toggleOutputButton = await page.$('#toggle-output');
  await toggleOutputButton.click();

  const runAllTestsButton = await page.$('#run-all-tests');
  await runAllTestsButton.click();

  const outputContent = await page.$('#output-run .output-content');

  let isTestFinished = false;
  while (!isTestFinished) {
    const coverageReport = await (await outputContent.getProperty('innerHTML')).jsonValue();

    if (coverageReport.includes('summary')) {
      isTestFinished = true;
      console.log('Coverage Report:\n\n', coverageReport);
    }

    await page.waitFor(1000);
  }

  browser.close();
})();
\end{lstlisting}
The code implements the following functionality. Line 4 to 8 launch the browser instance, open the Whisker Web interface at \texttt{http://localhost:8080}, and wait for the website to load. Line 10 to 20 select the test file, project file, toggle the output button, and finally click the run button. This code reflects how the user would behave when using the Whisker Web client. Line 22 to 36 read the TAP13 output content field every second until it contains the word \texttt{summary}, which indicates that the test-suite has been finished. It prints the content of the output to the command line, exits the browser, and the script. Using the \texttt{summary} based approach to identify when the test run has ended was not used in the final codebase. A callback-based approach was implemented (see the \texttt{Enhancements} chapter).

This simple script does not yield any performance improvement, but it
\begin{itemize}
  \item allows executing the test-suite in a headless environment
  \item and to automize the test runs by enhancing the \texttt{servant.js} file to support some command-line arguments
\end{itemize}

The goal of accelerating the test execution could not be achieved via Puppeteer. While running the test-suite, neither the CPU or GPU utilization became a bottleneck when executing the test (using intel\_gpu\_top and gotop for measurements). Therefore rendering could not be an issue in this context and a headless-mode not accelerate the execution.

The execution is limited by the number of times the Scratch VM updates the state of the loaded Scratch application, defined by the internal update frequency of the Scratch VM. Therefore, a closer examination of this frequency will be done in the section \textit{Modifying the update frequency of the Scratch VM}.


\subsection{Not evaluated}
The following two approaches have not been evaluated as the rendering was identified as not being the actual bottleneck at the situation at hand.

\begin{itemize}
  \item Hiding the Scratch Canvas Element via CSS:\newline
  Simply using a \texttt{display: none} CSS property on the canvas element, as browsers do not render such objects, while still keeping them in the DOM tree.
  \item Using OffscreenCanvas:\newline
  The OffscreenCanvas \cite{OffscreenCanvas} interface allows using the canvas context \textit{off screen}, in both window and web-worker context, therefore offloading the rendering computation from the main thread.
\end{itemize}




\section{Modifying the update frequency of the Scratch VM}
While running the tests in the web client, the actual CPU usage did only increase minimally (on an Intel Core i5-8250U). This indicated that the running Scratch VM instance did not use the available CPU resources when executing the test-suite.

Having a look at the implementation of how Whisker executes Scratch applications shows why. The following code is part of the \texttt{stepper.js} file in the Whisker-Main repository \cite{WhiskerSourceStep}:
\begin{lstlisting}[language=ES6]
step (callback) {
  // ...

  if (!this._interval) {
      log.debug('Starting stepper');
      this._interval = setInterval(this._executeNext.bind(this), this._stepTime);
      this._executeNext();
  }

  // ...
}
\end{lstlisting}
The \texttt{this.\_executeNext} method executes the next operation in an interval defined by \texttt{this.\_stepTime}. Decreasing \texttt{this.\_stepTime} would therefore increase the number of \texttt{this.\_executeNext} being called per minute and accelerate the execution.

Per default the \texttt{this.\_stepTime} is set in the \texttt{setStepTime} method of the \texttt{stepper.js}, which is called by the \texttt{setStepTime} method of the \texttt{wm-wrapper.js} \cite{WhiskerSourceSetup}:
\begin{lstlisting}[language=ES6]
async setup (project) {
  this.vm.runtime.currentStepTime = Runtime.THREAD_STEP_INTERVAL;
  this.stepper.setStepTime(Runtime.THREAD_STEP_INTERVAL);

  clearInterval(this.vm.runtime._steppingInterval);
  return await this.vm.loadProject(project);
}
\end{lstlisting}
The default \texttt{Runtime.THREAD\_STEP\_INTERVAL} frequency defined in the source of the Scratch VM is 1000 / 60, translating to intervals of \textasciitilde 16,6 or \textasciitilde 33,3 milliseconds in case \newline \texttt{Runtime.THREAD\_STEP\_INTERVAL\_COMPATIBILITY} is used. The latter is designated to support low power devices and to ensure the compatibility of Scratch 2.0 projects and is the default mode in Whisker.

Modifying the setup method of the VMWrapper class allows altering the predefined frequency with a user-defined value. The user can set this value in the Whisker Web interface via an input field \cite{WhiskerSourceVMWrapper}. As this value defines the acceleration it will from now on be called \textit{acceleration factor}:
\begin{lstlisting}[language=ES6]
// ...

class VMWrapper {

  // ...

  async setup (project, accelerationFactor) {
    const setStepTime = factor => {
        delete Runtime.THREAD_STEP_INTERVAL;
        Runtime.THREAD_STEP_INTERVAL = 1000 / 30 / factor;
        this.vm.runtime.currentStepTime = Runtime.THREAD_STEP_INTERVAL;
        this.stepper.setStepTime(Runtime.THREAD_STEP_INTERVAL);
        clearInterval(this.vm.runtime._steppingInterval);
        this.accelerationFactor = accelerationFactor;
    };
    setStepTime(accelerationFactor);

  // ...
\end{lstlisting}
Deleting the \texttt{THREAD\_STEP\_INTERVAL} property on the \texttt{Runtime} object is necessary, as it is defined as a getter-only static field, instead of a normal property. This prohibits to simply re-assign a value. Deleting and re-assigning the property resolves this issue.

At this point, users can start the web client and modify the acceleration factor as they wish:
\begin{figure}[H]
  \centering
  \includegraphics[width=0.7\linewidth]{./figures/whisker_screenshot_acceleration_factor.png}
  \caption{The \textit{Acceleration Factor} input allows the user to set the acceleration factor as needed.}
\end{figure}

This modification allows the user to increase the number of updates of the state of the Scratch VM per time unit, therefore reducing the amount of time needed to finish the test execution. At this point, the actual acceleration of the Scratch VM is already implemented, but a new problem arises. Only increasing the number of state updates of the VM is not sufficient, the modifications also have to ensure that the test code is respecting the acceleration. A simple example should illustrate this problem.

A Scratch application running with an acceleration factor of 1 (no acceleration) uses the wait instruction to wait 15 seconds, then makes an apple fall from top to bottom within 30 seconds and then shows a message for another 15 seconds. With an acceleration factor of 10, it will still take 15 seconds before the apple will fall, then only 3 seconds to make the apple fall from top to bottom as the number of state updates is ten times higher and then again 15 seconds to show the message. This behaviour is based on when Scratch triggers the \textit{make the apple fall after x seconds}, the \textit{show message after x seconds} and the \textit{hide message after x seconds} instructions. Those are not called after a specific amount of state updates have passed, but after the time \textit{x} has passed. Only increasing the number of state updates does not influence the value of \textit{x}.
In case our test code tests if after 30 seconds the apple is at half the way down the application canvas, it will fail when run with an acceleration factor of 10 as the apple will already reach the bottom of the canvas after 18 seconds.

To avoid this issue, every instruction used by the test code or the Scratch application code would need to perceive the time to pass by faster by the same factor as the acceleration factor. Instead of assessing the position of the apple after 30 seconds, the test code should assess the position after 3 seconds, while also the wait instruction of the Scratch application should only take a tenth of the 15 seconds at an acceleration factor of 1, resulting in 1,5 seconds with an acceleration factor of 10. The test instructions and application instructions all have to be modified to avoid inconsistencies leading to a differing test result between an acceleration factor of 1 and 10.

This can be described more abstractly. The amount of state updates of the VM is increased to accelerate the test run. Still, the actual test instructions have to be executed after the same amount of state updates of the VM as in a non-accelerated run. If a test instruction evaluates the VM state usually after 10 seconds, which means \textasciitilde 303 state updates at an acceleration factor of 1, it has to evaluate the VM state after 1 second at an acceleration factor of 10, to also evaluate after \textasciitilde 303 state updates. Additionally, wait, or timeout based instructions of the Scratch application code also have to be called earlier to avoid inconsistencies.

To sum this behavior up, we do have to increase the speed of time as perceived by the Scratch application.

The following list shows the necessary modifications and instrumentations to the Whisker and Scratch application instructions (controls and IO devices), to keep the state updates and controls in sync. The controls get called in the execute function of the \texttt{execute.js} \cite{ScratchSourceExecute}, here as the variable \texttt{blockFunction}:
\begin{lstlisting}[language=ES6]
const primitiveReportedValue = blockFunction(argValues, blockUtility);
\end{lstlisting}

Finding those controlls was achieved by two ways. Firstly searching all available Scratch control blocks for a time, duration or similar variables. Secondly the Scratch VM source code was searched for the usage of the name \texttt{DURATION}, \texttt{SECS} and \texttt{TIME}. The result set of both searches then yielded the following list of methods. The \texttt{this} keyword refers to the \texttt{VMWrapper.js} instance, which is used by Whisker.
\begin{itemize}
  \item Scratch internal
  \begin{itemize}
    \item \texttt{this.vm.runtime.\_primitives.control\_wait}
    \item \texttt{this.vm.runtime.\_primitives.looks\_sayforsecs}
    \item \texttt{this.vm.runtime.\_primitives.looks\_thinkforsecs}
    \item \texttt{this.vm.runtime.\_primitives.looks\_glidesecstoxy}
    \item \texttt{this.vm.runtime.\_primitives.looks\_glideto}
    \item \texttt{this.vm.runtime.ioDevices.clock.projectTimer}
  \end{itemize}

  \item Test driver and Whisker internal
  \begin{itemize}
    \item \texttt{this.getTotalTimeElapsed}
    \item \texttt{this.getRunTimeElapsed}
  \end{itemize}
\end{itemize}

The following subsections will describe the instrumentation and modification approaches for each of the controls.


\subsection{Instrumenting primitives: \texttt{looks\_sayforsecs}, \texttt{looks\_thinkforsecs}, \texttt{looks\_glidesecstoxy} and \texttt{looks\_glideto}}
The original \texttt{control\_wait} function represents the following block in a Scratch application:

\begin{figure}[H]
  \centering
  \includegraphics[width=0.3\linewidth]{./figures/wait.png}
  \caption{Wait block}
\end{figure}

The control block makes the application wait for the defined amount of seconds \cite{ScratchWikiWait}. The source code defining the behaviour of the wait block looks like this \cite{ScratchSourceWait}:
\begin{lstlisting}[language=ES6]
wait (args, util) {
  if (util.stackTimerNeedsInit()) {
      const duration = Math.max(0, 1000 * Cast.toNumber(args.DURATION));

  // ...
\end{lstlisting}

The \texttt{args.DURATION} is the property which has to be modified to reduce the waiting time of the block. To achieve this behavior, the waiting duration has to be reduced by the factor the state updates are increased - the acceleration factor. When running the application with an acceleration factor of 10 instead of 1, the duration has to be divided by factor 10. We can instrument the function as follows:

\begin{lstlisting}[language=ES6]
// The acceleration factor is defined by how much faster the time has to go by to
// compensate for the increased frequency of the state updates. Following our
// example above, we will use an acceleration factor of 10 here.
const accelerationFactor = 10;
const original = this.vm.runtime._primitives.control_wait;
const instrumented = (args, util) => {
    const clone = {...args};
    clone.DURATION = args.DURATION / accelerationFactor;
    return original(clone, util);
};
this.vm.runtime._primitives.control_wait = instrumented;
\end{lstlisting}

The same approach can be used for \texttt{looks\_sayforsecs}, \texttt{looks\_thinkforsecs}, \texttt{looks\_glidesecstoxy} and \texttt{looks\_glideto}, also in this case the property \texttt{args.SECS} has to be modified \cite{ScratchWikiThink, ScratchWikiSay, ScratchSourceThink, ScratchSourceSay, ScratchWikiProjectGlideTo, ScratchWikiProjectGlideSecsToXY, ScratchSourceProjectGlideTo, ScratchSourceGlideSecsToXY}. The following code shows an abstract implementation of this instrumentation approach. To avoid that the instrumentation is being applied mutliple times, the boolean flag \texttt{isInstrumented} is used.
\begin{lstlisting}[language=ES6]
  // ...

  this.instrumentPrimitive('control_wait', 'DURATION');
  this.instrumentPrimitive('looks_sayforsecs', 'SECS');
  this.instrumentPrimitive('looks_thinkforsecs', 'SECS');
  this.instrumentPrimitive('motion_glidesecstoxy', 'SECS');
  this.instrumentPrimitive('motion_glideto', 'SECS');

  // ...
}

instrumentPrimitive (primitive, argument) {
  const original = this.vm.runtime._primitives[primitive];

  if (original.isInstrumented) {
      return;
  }

  const instrumented = (args, util) => {
      const clone = {...args};
      clone[argument] = args[argument] / this.accelerationFactor;
      return original(clone, util);
  };
  instrumented.isInstrumented = true;
  this.vm.runtime._primitives[primitive] = instrumented;
}
\end{lstlisting}




\subsection{Instrumenting ioDevices: \texttt{clock.projectTimer}}
The original \texttt{clock.projectTimer} function represents the following block in a Scratch application:

\begin{figure}[H]
  \centering
  \includegraphics[width=0.3\linewidth]{./figures/timer.png}
  \caption{Timer block}
\end{figure}

The timer block is a sensing block representing the time since the application was started, or the last timer reset block was triggered \cite{ScratchWikiProjectTimer}. The source code defining the behaviour of the time block looks like this \cite{ScratchSourceProjectTimer}:
\begin{lstlisting}[language=ES6]
projectTimer () {
    if (this._paused) {
        return this._pausedTime / 1000;
    }
    return this._projectTimer.timeElapsed() / 1000;
}
// ...
\end{lstlisting}

The value returned by this function has to be divided by the \texttt{this.accelerationFactor} to behave, as if an increased amount of time has passed by. We can instrument the function as follows:
\begin{lstlisting}[language=ES6]
// The acceleration factor is defined by how much faster the time has to go by to
// compensate for the increased frequency of the state updates. Following our
// example above, we will use an acceleration factor of 10 here.
const device = this.vm.runtime.ioDevices.clock;
const original = clock.projectTimer;

if (original.isInstrumented) {
    return;
}

const instrumented = () => original.call(device) * this.accelerationFactor;
instrumented.isInstrumented = true;
device[method] = instrumented;
\end{lstlisting}
Using \texttt{original.call(device)} instead of \texttt{original()} ensures that the function call is executed in the context of the clock instance.


\subsection{Modifying \texttt{getTotalTimeElapsed}, \texttt{getRunTimeElapsed}}
The returned values of those functions exposed by the test driver have to be increased by the factor the state updates are accelerated.

\begin{lstlisting}[language=ES6]
// ...
getTotalTimeElapsed () {
    return (Date.now() - this.startTime) * this.accelerationFactor;
}

// ...

getRunTimeElapsed () {
    return (Date.now() - this.runStartTime) * this.accelerationFactor;
}
// ...
\end{lstlisting}

As \texttt{getRunTimeElapsed} is also used by calls to \texttt{runForTime}, \texttt{runUntil}, \texttt{runUntilChanges}, \texttt{runForSteps} and random inputs being performed, all those functions will respect the acceleration.


\subsection{Benchmarking this instrumentation approach}
This section does not replace and is independent of the evaluation. It only showcases the result of the frequency-based acceleration in an undemanding but not as precise way, to indicate how the changes affect the execution duration. For benchmarking different frequencies, the Catch Game and a test-suite with 28 tests have been selected, and the time in milliseconds is measured for each test. The following code shows a modified TestRunner class, augmented with the benchmark measurements and an automatic CSV generation and download, storing the results of all tests with their name and runtime duration in milliseconds (see \texttt{benchmarkRecorder.set(test.name, end - start);}).
\begin{lstlisting}[language=ES6]
class TestRunner extends EventEmitter {

  // ...

  async runTests (vm, project, tests, props) {
      // ...

      const benchmarkRecorder = new Map();

      for (const test of tests) {
          let result;

          // record the start time
          const start = window.performance.now();

          // ...

          } else {
              // execute the test
              result = await this._executeTest(vm, project, test, props);

              // ...
          }

          // record the end time
          const end = window.performance.now();

          // store the difference between start and end time of the test mapped by
          // the test name
          benchmarkRecorder.set(test.name, end - start);

          results.push(result);
      }

      // generate and download the CSV with a test name to duration mapping
      this.downloadBenchmarkRecorderContentAsCSV(benchmarkRecorder);

      // ...
  }

  downloadBenchmarkRecorderContentAsCSV (benchmarkRecorder) {
      const data = Array.from(benchmarkRecorder)
        .map(e => e.join(','))
        .join('\n');
      const CSV = `data:text/csv;charset=utf-8,Test,Duration\n${data}`;
      const encodedUri = encodeURI(CSV);
      const link = document.createElement('a');
      link.setAttribute('href', encodedUri);
      link.setAttribute('download', `${new Date()}.csv`);
      document.body.appendChild(link);
      link.click();
      link.parentNode.removeChild(link);
  }

  // ...
\end{lstlisting}

To run the tests automatically, the author used the already existing \texttt{servant.js} script to execute the tests with an acceleration factor of 1, 2, 4, 8, and 10 in headless mode. The following heatmap shows a visualization of the benchmarking results:
\begin{figure}[H]
  \centering
  \includegraphics[width=\linewidth]{./figures/benchmark.png}
  \caption{The percentage information next to the absolute seconds shows the runtime of that specific test for that specific acceleration factor in relation to the non-accelerated default run. Green means the test has the same speed or is faster than the non-accelerated run.\newline
  The first three tests seem to run slower when executed with an acceleration factor, but in absolute numbers, the  additional accumulated execution duration is less than 30 ms.}
\end{figure}
The benchmark results show that the tenfold accelerated run resulted in the lowest total runtime duration, a reduction from \textasciitilde 161699 ms to \textasciitilde 19977 ms or about -88 \%. Additionally, to the successful acceleration, the test results did not differ from the non-accelerated results. This means no test did fail for this example test-suite, done on the Catch Game Scratch application.

The benchmark indicates that the approach works, as the execution duration is reduced, and the tests still show the same results. Still, there are some possible threats to the frequency approach, which the next section will highlight.


\subsection{Threats to the frequency approach}
Nevertheless, as soon as time measurements are used by the test programmer, which are not routed through the time measurement functions exposed by the test driver (\texttt{getTotalTimeElapsed} or \texttt{getRunTimeElapsed}), the time or duration cannot be modified when running the tests. The following example will illustrate this problem.

\begin{lstlisting}[language=ES6]
if (t.getRunTimeElapsed() > 500) {
    t.assert.equal(banana.y, banana.old.y, 'Banana must not fall in the first second.');
}
\end{lstlisting}

\begin{lstlisting}[language=ES6]
if (Date.now() - startTime > 500) {
    t.assert.equal(banana.y, banana.old.y, 'Banana must not fall in the first second.');
}
\end{lstlisting}

In the first test, the assert is called depending on the value of \texttt{getRunTimeElapsed}. In the second test \texttt{Date.now()} is used. When accelerated, the duration after which the assert is called cannot be reduced by including the acceleration factor. Therefore more state updates will be computed, and the assert will be called after more state updates than in the non-accelerated mode. This can lead to a failing assertion. Such a usage of the JavaScript date object is a threat to this acceleration approach. None of the tests currently used or created at the Chair of Software Engineering II of the University of Passau use the JavaScript date object this way.


\subsection{Why the test failure rate increases with high CPU load}
While testing higher frequencies, the failure rate increased. When using acceleration factors higher than 10, tests failed, which worked flawlessly with no acceleration. The \textit{Evaluation} chapter includes more data on this. The reason why under high CPU loads produced by high frequencies or other programs being executed on the computer, while running the test-suit, increases the number of failures will be shown in this section.

To explain this behavior we have to examine how the Scratch VM execution works. The \texttt{Secquencer} Class controlls the execution sequence in the Scratch VM. The following code shows the \texttt{stepThreads} method, which is called by Whisker to execute the next execution step.
\begin{lstlisting}[language=ES6]
stepThreads () {
  // Work time is 75% of the thread stepping interval.
  const WORK_TIME = 0.75 * this.runtime.currentStepTime;

  // ...

  // Conditions for continuing to stepping threads:
  // 1. We must have threads in the list, and some must be active.
  // 2. Time elapsed must be less than WORK_TIME.
  // 3. Either turbo mode, or no redraw has been requested by a primitive.
  while (this.runtime.threads.length > 0 &&
          numActiveThreads > 0 &&
          this.timer.timeElapsed() < WORK_TIME &&
          (this.runtime.turboMode || !this.runtime.redrawRequested)) {

      // ...
\end{lstlisting}
As the conditions in the \texttt{while} statement show, Scratch is not evaluating, if, since the last time the logic in the while block was executed, this logic was finished. This means the execution of the while loop logic might need longer than the actual time being available in terms of \texttt{WORK\_TIME}. With a suitable acceleration factor, there will always be enough time on modern computing hardware to finish the last execution triggered by the while block. When running higher frequencies, this might lead to unexpected behavior, timing issues, and thereby test failures.


\subsection{Alternative Approach: Instrumenting the Scratcht's Timer class}
The Timer class of the Scratch VM source is meant to be used as \flqq A utility for accurately measuring time\frqq{} \cite{ScratchSourceUtilTimer}. Several classes in the Scratch VM repository use the Timer class, for example, the Sequencer class and BlockUtil class. As the Timer class does export a \texttt{timeElapsed} method, to measure time since a timer was started, instrumenting this class could be an alternative and more abstract approach compared to the instrumentation of each method on its own, as shown in the previous section.

Such an instrumentation could be implemented in the \texttt{whisker-web/src/index.js}:
\begin{lstlisting}[language=ES6]
const Timer = require('scratch-vm/src/util/timer');

// ...
const _runTestsWithCoverage = async function (vm, project, tests) {
  const accelerationFactor = Number(document.querySelector('#acceleration-factor').value);

  if (!Timer.prototype.isInstrumented) {
    const org = Timer.prototype.timeElapsed;
    Timer.prototype.timeElapsed = function timeElapsed () {
        const duration = org.call(this);
        if (Whisker.scratch.vm.runtime.sequencer.timer === this) {
            return duration;
        }

        return duration * accelerationFactor;
    };
    Timer.prototype.isInstrumented = true;
  }
\end{lstlisting}
This approach works in terms of it accelerates the execution, but some of the control blocks are not using the Timer class, and therefore tests still fail. As this approach would again need specific instrumentations on devices and control blocks, the approach from the previous section was implemented. This avoids situations in which logic is covered by the instrumentation, which actually should not be instrumented, producing unwanted side effects.


\subsection{Alternative Approach: Instrumenting JavaScript \texttt{Date.now}, \texttt{setTimeout} and \texttt{setInterval}}
Instead of writing code that modifies how specific parts of the Scratch- and Whiskerlogic perceive time, a generic solution can be implemented. For this approach, three functions which are standard in every JavaScript environment have to be instrumented:

\begin{itemize}
  \item \texttt{Date.now()}, returns the current time as UNIX timestamp. Increasing the return value by the acceleration factor would make the calling code perceive time faster.
  \item \texttt{setTimeout(callback, duration)}, calls a callback after a specified duration has been passed. Reducing the duration argument by the acceleration factor would make the calling code perceive time faster.
  \item \texttt{setInterval(callback, duration)}, calls a callback repeatedly after a specified duration has been passed. Reducing the duration argument by the acceleration factor would make the calling code perceive time faster.
\end{itemize}

The following code shows a functional implementation, added to the \texttt{whisker-web/src/index.js}:
\begin{lstlisting}[language=ES6]
// ...

const makeTimeFlyByFaster = accFactor => {
    const nowOrg = Date.now;
    let startTime = null;
    Date.now = () => {
        if (!startTime) {
            startTime = nowOrg();
            return startTime;
        }

        const currentTime = nowOrg();
        const diff = currentTime - startTime;
        return startTime + (diff * accFactor);
    };

    const setTimeoutOrg = window.setTimeout;
    window.setTimeout = function setTimeout (callback, duration) {
        return setTimeoutOrg(callback, duration / accFactor);
    };

    const setIntervalOrg = window.setInterval;
    window.setInterval = function setInterval (callback, duration) {
        return setIntervalOrg(callback, duration / accFactor);
    };

    const backToNormalTime = () => {
        startTime = null;
        Date.now = nowOrg;
        window.setTimeout = setTimeoutOrg;
        window.setInterval = setIntervalOrg;
    };

    return backToNormalTime;
};

// ...

const _runTestsWithCoverage = async function (vm, project, tests) {
    // ...

    const accelerationFactor = Number(document.querySelector('#acceleration-factor').value);
    const backToNormalTime = makeTimeFlyByFaster(accelerationFactor);
    const summary = await Whisker.testRunner.runTests(vm, project, tests, {CoverageGenerator});
    backToNormalTime();
    const coverage = CoverageGenerator.getCoverage();

    // ...
\end{lstlisting}
This approach is generic and requires only minimal code changes. No other changes apart from the input field to read the \texttt{accelerationFactor} variable are necessary.

The main disadvantage and reason why this approach was not used, is that the approach is that generic, that all code executed is affected by it. Unwanted side effects cannot be ruled out. Because of this reason, modifying built-in JavaScript functionality is considered as bad practice in JavaScript programming.

For a short-term modification, only used to demonstrate the effect of the acceleration, this would be sufficient, but in the context of a long-term project, maintainability would suffer. Explicitly modifying the necessary control structures seems to be the better choice from the maintaining perspective and avoids unwanted side effects.




\section{Parallelizing test execution}
As test-suites usually consist of several tests, distributing those over multiple Scratch or Whisker instances and executing them in parallel could reduce execution duration. Necessary for this approach is that tests are independently defined as:
\begin{quote}
  Test suites are trivially parallelizable if tests are independent, that is, if one test does not rely on the system state established by a previous test and it is free of interference from other tests. \cite{Parsa16}
\end{quote}
As for each test defined in a test-suite the \texttt{VMWrapper.setup} method runs a reload of the Scratch application via a call to the \texttt{VirtualMachine.loadProject} method, the state of the Scratch application is reset between each test execution. Independence between the executions is thereby given.

The following section will evaluate such an approach to distribute tests.


\subsection{Parallelizing test execution in one Whisker-Web instance}

\subsubsection{.. in one execution context}
The first approach was to modify Whisker-Web to instantiate multiple instances of Scratch VMs, including multiple canvas elements, each for a single test in the test file. For example, if a test-suite includes four individual tests, four instances of the Scratch VM should be instantiated, each to execute one of the tests. After a proof of concept (PoC), a further approach could then be used to implement a pool of Scratch VMs, which select and execute a subset of the available tests in parallel.

Implementing the PoC is a simple task by creating multiple instances after loading and parsing the tests and creating a canvas element for each of the instances. Generating a map, mapping each test name to a new Scratch instance with another canvas element, and adding those dynamically to the DOM would implement a worker pool of Scratch VMs.

Executing this pool results in a warning \flqq Central dispatch replacing existing service provider for extensions\frqq{}. Searching the Scratch VM's source code for this warning shows the following method in the \texttt{central-dispatch.js} file \cite{ScratchSourceCentralDispatch}:
\begin{lstlisting}[language=ES6]
class CentralDispatch extends SharedDispatch {
  // ...

  setServiceSync (service, provider) {
    if (this.services.hasOwnProperty(service)) {
        log.warn(`Central dispatch replacing existing service provider for ${service}`);
    }
    this.services[service] = provider;
  }

  // ...
module.exports = new CentralDispatch();
\end{lstlisting}
As the \texttt{setServiceSync} method warns, the same service is set multiple times. The actual problem here is the last line which exports not the class, but an instance of it. This means the \texttt{CentralDispatch} is not loaded as the instance of a class but as a singleton. Only one instance can exist in the execution context. In Whisker-Web, the execution context is one browser tab. As multiple Scratch instances in the same tab will rely on the same \texttt{CentralDispatch} singleton instance, this approach can not work, as the Scratch instances can not be fully separated from each other.

Additionally, having multiple Scratch instances in one tab also limits the performance, as multithreading is not allowed in a single tab. Working around the thread limitation was identified as the next target to allow parallel test execution.


\subsubsection{.. in multiple execution contexts in one tab via WebWorkers}
Iframes and similar different execution contexts have been considered, but as those use the same thread as the parent window, they are limited when it comes to improving performance. Web Workes are the only standard conform way to use multiple threads controlled from one tab. They would also solve the singleton issue of Scratch VM instances. This approach will be evaluated in this section.

To test this approach, trying to instantiate a Scratch instance in a WebWorker with the help of the OffscreenCanvas elements would be sufficient as a PoC. This fails soon, as the Scratch VM instantiates the Scratch Renderer, which needs the document object to exist. Without modifying the Scratch Renderer source to support WebWorkers, this approach can not work. The alternative approach to stub the behavior of the document object within the worker was also rejected because of the increased maintainability efforts such an approach would need (see \textit{Decoupling the Scratch VM from the renderer}).

Therefore this approach was dropped to avoid modifications of the Scratch source code and the following intensive maintaining.


\subsection{Parallelizing test execution via multiple Whisker-Web instances}
As described in the last subsection, spawning multiple tabs and distributing the tests between those would solve the identified singleton and multithreading issues without modifying the existing Whisker or the existing Scratch codebase.

For the popular JavaScript test runner \textit{Karma} \cite{Karma} two different parallelization plugins exist, \textit{Karma Sharding} \cite{KarmaSharding} and \textit{Karma Parallel} \cite{KarmaParallel}. Those two plugins follow different approaches to distribute tests but use the same concept in regards to distributing them over several browser tabs to parallelize execution. The already existing Puppeteer based Servant used at the beginning of this chapter can be modified to implement a similar approach. It can be used to spawn and control those tabs. Implementing additional logic to read and split the original test-suite file into multiple files is described in this section.

The following code illustrates this \textit{test splitting} with an example using this test-suite file \texttt{test.js}:
\begin{lstlisting}[language=ES6]
// test.js
// .. some hundred lines of test code

module.exports = [
  {
      test: testAppleGameOver,
      name: 'Apple Game Over Test',
      description: 'Tests if an apples falling to the ground end the game.',
      categories: ['fruit interaction', 'apple', 'input']
  },
  {
      test: testAppleGameOverMessage,
      name: 'Apple Game Over Message Test',
      description: 'Tests if an apples falling to the ground display a game over message.',
      categories: ['fruit interaction', 'apple', 'input']
  },
];
\end{lstlisting}

The test-suite file is split up into two files for two tabs:
\begin{lstlisting}[language=ES6]
// test_1.js
// .. same some hundred lines of test code as in the test.js

module.exports = [
  {
      test: testAppleGameOverMessage,
      name: 'Apple Game Over Message Test',
      description: 'Tests if an apples falling to the ground display a game over message.',
      categories: ['fruit interaction', 'apple', 'input']
  },
];
\end{lstlisting}

\begin{lstlisting}[language=ES6]
// test_2.js
// .. same some hundred lines of test code as in the test.js

module.exports = [
  {
      test: testAppleGameOver,
      name: 'Apple Game Over Test',
      description: 'Tests if an apples falling to the ground end the game.',
      categories: ['fruit interaction', 'apple', 'input']
  },
];
\end{lstlisting}
Instead of one test-suite file, the script generates two test-suite files, each only exporting half the test declarations in the exported array. Those two test-suite files can then be executed in parallel in two tabs.

The following code snippet is taken from a working example of this approach. The \texttt{testPath} reflects the path to the test file, the \texttt{numberOfTabs} reflects the number of tabs and the \texttt{isHeadless} reflects if the tests should run in the headless mode.
\begin{lstlisting}[language=ES6]
// ...

init();

async function init() {
  const exportStatement = 'module.exports =';
  const test = fs.readFileSync(testPath, { encoding: 'utf8' });
  const testArrayStartIndex = test.indexOf(exportStatement) + exportStatement.length;
  const testSourceWithouExportArray = test.substr(0, testArrayStartIndex);
  const evaledTest = eval(test);

  const singleTestSources = splitTestsSourceCodeIntoSingleTestSources(evaledTest);
  const testSourcesPerTab = distributeTestSourcesOverTabs(numberOfTabs, singleTestSources);
  const paths = writeTestSourceFiles(testSourcesPerTab, testPath, testSourceWithouExportArray);

  const browser = await puppeteer.launch({ headless: isHeadless });

  // the actual test run per page
  const promises = paths.map(path => runTests(path, browser));

  // ...
}

// ...

function splitTestsSourceCodeIntoSingleTestSources(tests) {
  return tests.map(test => {
    const testDescription = JSON.parse(JSON.stringify(test));
    testDescription.test = test.test.name;

    return JSON.stringify(testDescription, null, 2)
      .replace('"name"', 'name')
      .replace('"description"', 'description')
      .replace('"categories"', 'categories')
      .replace('"test"', 'test')
      .replace(`"${test.test.name}"`, `${test.test.name}`);
  });
};

function distributeTestSourcesOverTabs(tabs, singleTestSources) {
  let index = 0;
  const testSourcesPerTab = [];

  while (singleTestSources.length) {
    testSourcesPerTab[index] = testSourcesPerTab[index]
      ? testSourcesPerTab[index].concat(', ').concat(singleTestSources.pop())
      : singleTestSources.pop();

    index++;

    if (index > tabs - 1) {
      index = 0;
    }
  }

  return testSourcesPerTab;
}

function writeTestSourceFiles(testSourcesPerTab, whiskerTestPath, testSourceWithoutExportArray) {
  return testSourcesPerTab.map((testSources, index) => {
    const path = `${whiskerTestPath}_${index + 1}.js`;
    fs.writeFileSync(path, `${testSourceWithoutExportArray} [${testSources}]`, { encoding: 'utf8' });
    return path;
  });
}
\end{lstlisting}

Up to as many tabs as threads are allowed. Using more tabs results in timing issues when running the Scratch application and increases the test failure rate. The execution duration for the example Catch Game could be reduced to \textasciitilde 50 seconds for a test file (including 28 tests) from about 168 seconds non-parallelized execution duration.

The disadvantage of this approach is the overhead cost for creating multiple tabs, which can be around one or two seconds per tab. Therefore this approach yields better results when running test-suites with an increased number of tests. Also, multiple tests have to exist in a test-suite to allow parallelization.
